spack:
  include:
  - config.yml
  - packages.yml
  - compilers.yml
  - modules.yml
  view: false
  concretization: separately
  definitions:
  - arch: [arch=linux-rocky8-zen2]
  - compilers: [gcc@9.3.0, intel@2021.4.0]
  - core_compilers: [gcc@8.5.0]
  - cuda: [cuda@11.0.0, cuda@11.4.0]
  - hdf5: [hdf5]
  - mpi: [openmpi@4.1.0%gcc@9.3.0 arch=linux-rocky8-zen2 ^cuda@11.0.0 arch=linux-rocky8-zen2, openmpi@4.1.1%gcc@9.3.0 arch=linux-rocky8-zen2 ^cuda@11.4.0 arch=linux-rocky8-zen2]
  - compiler_arch_mpi: [gcc@9.3.0 arch=linux-rocky8-zen2 ^openmpi arch=linux-rocky8-zen2, intel@2021.4.0 arch=linux-rocky8-zen2 ^intel-oneapi-mpi arch=linux-rocky8-zen2]
  - build_utils: [cmake, git, git-lfs]
  - libs: [fftw, intel-oneapi-mkl, amdblis, boost]
  - containers: [singularity]
  - gpu: [nccl]
  # It is important to pass full spec for dependencies when we are using externals including arch
  # Else Spack will try to build it AGAIN.
  # In this case we cannot really use buildable=False as we want Spack to build another version 
  # alongside system provided one
  - osu: [osu-micro-benchmarks%gcc@9.3.0 arch=linux-rocky8-zen2 ^cuda@11.4.0 arch=linux-rocky8-zen2 ^openmpi@4.1.1 arch=linux-rocky8-zen2, osu-micro-benchmarks%gcc@9.3.0 arch=linux-rocky8-zen2 ^cuda@11.0.0 arch=linux-rocky8-zen2 ^openmpi@4.1.0 arch=linux-rocky8-zen2]
  - cuda_arch:
    - matrix:
      - [$cuda]
      - [$arch]
  - benchmarks:
    - $osu
    - matrix:
      - [$gpu]
      - [$%compilers]
      - [$arch]
      - [$^cuda_arch]
  specs:
  - matrix:
    - [$cuda]
    - [$%compilers]
    - [$arch]
  - matrix:
    - [$build_utils]
    - [$%core_compilers]
    - [$arch]
   - matrix:
    - [$libs]
    - [$%compilers]
    - [$arch]
  - matrix:
    - [$containers]
    - [$%compilers]
    - [$arch]
  - matrix:
    - [$hdf5]
    - [$%compiler_arch_mpi]
  - $mpi
  - $benchmarks
  - singularity%gcc@9.3.0 arch=linux-rocky8-skylake_avx512
  - boost%gcc@9.3.0 arch=linux-rocky8-skylake_avx512
  # The new rocky OS does not provide static libraries and so we cannot build boost with intel
  # Need to contact support team of JSC to get statis libraries and then add this to spec
  # - boost%intel@2021.4.0 arch=linux-rocky8-skylake_avx512 ^intel-oneapi-mkl
